package com.aliyun.vodplayer.demo.activity.advance;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.BuildConfig;
import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.CleanLeakUtils;
import com.aliyun.vodplayer.demo.utils.VidStsUtil;

import java.lang.ref.WeakReference;

import static com.aliyun.vodplayer.demo.R.id.vid;

/**
 */

public class DemoVidstsActivity extends BaseAppCompatActivity {

    private EditText mVidEdit;
    private EditText mAkIdEdit;
    private EditText mAkSecretEdit;
    private EditText mSecurityTokenEdit;
    private boolean inRequest = false;
    private String mVid;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_vidsts);
        //填写vid和。
        mVidEdit = (EditText) findViewById(vid);
        mAkIdEdit = (EditText) findViewById(R.id.akId);
        mAkSecretEdit = (EditText) findViewById(R.id.akSecret);
        mSecurityTokenEdit = (EditText) findViewById(R.id.scuToken);

        if(!BuildConfig.DEBUG){
            findViewById(R.id.sts_view).setVisibility(View.GONE);
        }
        //点击事件
        findViewById(R.id.no_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startNoSkinActivity();
            }
        });


    }


    private void startNoSkinActivity() {

        mVid = mVidEdit.getText().toString();
        final String akId = mAkIdEdit.getText().toString();
        final String akSecret = mAkSecretEdit.getText().toString();
        final String scuToken = mSecurityTokenEdit.getText().toString();


        if (isInfoNotFill(mVid, akId, akSecret, scuToken)) {
            if(inRequest){
                return;
            }
            inRequest = true;
            VidStsUtil.getVidSts(new MyStsListener(this));

        } else {
            Intent intent = new Intent();
            intent.setClass(this, NoSkinActivity.class);
            //将vid等信息传递过去
            intent.putExtra("type", "vidsts");
            intent.putExtra("vid", mVid);
            intent.putExtra("akId", akId);
            intent.putExtra("akSecret", akSecret);
            intent.putExtra("securityToken", scuToken);

            startActivity(intent);
        }

    }


    private static class MyStsListener implements VidStsUtil.OnStsResultListener{

        private WeakReference<DemoVidstsActivity> weakActivity ;

        public MyStsListener(DemoVidstsActivity activity)
        {
            weakActivity = new WeakReference<DemoVidstsActivity>(activity);
        }

        @Override
        public void onSuccess(String akid, String akSecret, String token) {
            DemoVidstsActivity demoVidstsActivity = weakActivity.get();
            if(demoVidstsActivity != null){
                demoVidstsActivity.onStsSuccess(akid,akSecret,token);
            }
        }

        @Override
        public void onFail() {
            DemoVidstsActivity demoVidstsActivity = weakActivity.get();
            if(demoVidstsActivity != null){
                demoVidstsActivity.onStsFail();
            }
        }
    }

    private void onStsFail() {
        Toast.makeText(getApplicationContext(), R.string.request_vidsts_fail, Toast.LENGTH_LONG).show();
        inRequest = false;
    }

    private void onStsSuccess(String akid, String akSecret, String token) {
        Intent intent = new Intent();
        intent.setClass(DemoVidstsActivity.this.getApplicationContext(), NoSkinActivity.class);
        //将vid等信息传递过去
        intent.putExtra("type", "vidsts");
        intent.putExtra("vid", mVid);
        intent.putExtra("akId", akid);
        intent.putExtra("akSecret", akSecret);
        intent.putExtra("securityToken", token);

        startActivity(intent);

        inRequest = false;
    }


    private boolean isInfoNotFill(String vid, String akId, String akSecret, String scuToken) {
        return TextUtils.isEmpty(vid) || TextUtils.isEmpty(akId) || TextUtils.isEmpty(akSecret) || TextUtils.isEmpty(scuToken);
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
